<template>
    <BasicLayout>
        <template #wrapper>
            <el-card class="box-card">
                <el-form ref="queryForm" :model="queryParams" :inline="true" label-width="68px">
                    <el-form-item label="机器编号" prop="machineId">
                        <el-select v-model="queryParams.machineId" placeholder="请选择机器编号" filterable clearable
                            size="small">
                            <el-option v-for="item in machineIdOptions" :key="'machine' + item.value"
                                :label="item.label" :value="item.value">
                            </el-option>
                        </el-select>
                    </el-form-item>
                    <!-- <el-form-item label="设备码" prop="biosId"><el-input v-model="queryParams.biosId" placeholder="请输入设备码"
                            clearable size="small" @keyup.enter.native="handleQuery" />
                    </el-form-item> -->

                    <el-form-item label="时间范围">
                        <el-date-picker v-model="times" type="daterange" align="right" unlink-panels range-separator="至"
                            start-placeholder="开始日期" end-placeholder="结束日期" :picker-options="pickerOptions">
                        </el-date-picker>
                    </el-form-item>
                    <el-form-item>
                        <el-button type="primary" icon="el-icon-search" size="mini" @click="handleQuery">搜索</el-button>
                        <el-button icon="el-icon-refresh" size="mini" @click="resetQuery">重置</el-button>
                    </el-form-item>
                </el-form>

                <el-row :gutter="10" class="mb8">
                    <el-col :span="1.5">
                        <el-button v-permisaction="['admin:mmAlarmLog:add']" type="primary" icon="el-icon-plus"
                            size="mini" @click="handleAdd">新增
                        </el-button>
                    </el-col>
                    <el-col :span="1.5">
                        <el-button v-permisaction="['admin:mmAlarmLog:edit']" type="success" icon="el-icon-edit"
                            size="mini" :disabled="single" @click="handleUpdate">修改
                        </el-button>
                    </el-col>
                    <el-col :span="1.5">
                        <el-button v-permisaction="['admin:mmAlarmLog:remove']" type="danger" icon="el-icon-delete"
                            size="mini" :disabled="multiple" @click="handleDelete">删除
                        </el-button>
                    </el-col>
                    <el-col :span="1.5">
                        <el-popconfirm class="delete-popconfirm" title="确定要导出记录吗?" confirm-button-text="确定"
                            @confirm="handleExport">
                            <el-button slot="reference" v-permisaction="['admin:mmAlarmLog:export']"
                                icon="el-icon-files" size="mini">导出
                            </el-button>
                        </el-popconfirm>
                    </el-col>
                    <el-col :span="1.5">
                        <el-popconfirm class="delete-popconfirm" title="确认要清除所有吗?" confirm-button-text="清除"
                            @confirm="handleClearAll()">
                            <el-button slot="reference" v-permisaction="['admin:mmAlarmLog:clearAll']" type="danger"
                                icon="el-icon-delete-solid" size="mini">
                                清除所有
                            </el-button>
                        </el-popconfirm>
                    </el-col>
                </el-row>

                <el-table v-loading="loading" :data="mmAlarmLogList" @selection-change="handleSelectionChange">
                    <el-table-column type="selection" width="55" align="center" />
                    <el-table-column label="设备id" align="center" prop="machineId" :show-overflow-tooltip="true" />
                    <el-table-column label="设备码" align="center" prop="biosId" :show-overflow-tooltip="true" />
                    <el-table-column label="内容" align="center" prop="content" :show-overflow-tooltip="true" />
                    <el-table-column label="创建时间" align="center" prop="createdAt" width="155px" sortable="custom">
                        <template slot-scope="scope">
                            <span>{{ parseTime(scope.row.createdAt) }}</span>
                        </template>
                    </el-table-column>
                    <el-table-column label="操作" align="center" class-name="small-padding fixed-width">
                        <template slot-scope="scope">
                            <el-popconfirm class="delete-popconfirm" title="确认要修改吗?" confirm-button-text="修改"
                                @confirm="handleUpdate(scope.row)">
                                <el-button slot="reference" v-permisaction="['admin:mmAlarmLog:edit']" size="mini"
                                    type="text" icon="el-icon-edit">修改
                                </el-button>
                            </el-popconfirm>
                            <el-popconfirm class="delete-popconfirm" title="确认要删除吗?" confirm-button-text="删除"
                                @confirm="handleDelete(scope.row)">
                                <el-button slot="reference" v-permisaction="['admin:mmAlarmLog:remove']" size="mini"
                                    type="text" icon="el-icon-delete">删除
                                </el-button>
                            </el-popconfirm>
                        </template>
                    </el-table-column>
                </el-table>

                <pagination v-show="total > 0" :total="total" :page.sync="queryParams.pageIndex"
                    :limit.sync="queryParams.pageSize" @pagination="getList" />

                <!-- 添加或修改对话框 -->
                <el-dialog :title="title" :visible.sync="open" width="500px">
                    <el-form ref="form" :model="form" :rules="rules" label-width="80px">

                        <el-form-item label="设备id" prop="machineId">
                            <el-select v-model="form.machineId" placeholder="请选择">
                                <el-option v-for="dict in machineIdOptions" :key="dict.value" :label="dict.label"
                                    :value="dict.value" />
                            </el-select>
                        </el-form-item>
                        <el-form-item label="设备码" prop="biosId">
                            <el-input v-model="form.biosId" placeholder="设备码" />
                        </el-form-item>
                        <el-form-item label="内容" prop="content">
                            <el-input v-model="form.content" placeholder="内容" />
                        </el-form-item>
                    </el-form>
                    <div slot="footer" class="dialog-footer">
                        <el-button type="primary" @click="submitForm">确 定</el-button>
                        <el-button @click="cancel">取 消</el-button>
                    </div>
                </el-dialog>
            </el-card>
        </template>
    </BasicLayout>
</template>

<script>
import { addMmAlarmLog, delMmAlarmLog, getMmAlarmLog, listMmAlarmLog, updateMmAlarmLog, clearAllAlarmLog, exportMmAlarmLog } from '@/api/admin/mm-alarm-log'
import { getMmMachineList } from '@/api/admin/mm-machine'
import { resolveBlob } from '@/utils/zipdownload'

export default {
    name: 'MmAlarmLog',
    components: {
    },
    data() {
        return {
            // 遮罩层
            loading: true,
            // 选中数组
            ids: [],
            // 非单个禁用
            single: true,
            // 非多个禁用
            multiple: true,
            // 总条数
            total: 0,
            // 弹出层标题
            title: '',
            // 是否显示弹出层
            open: false,
            isEdit: false,
            // 类型数据字典
            typeOptions: [],
            machineIdOptions: [],
            mmAlarmLogList: [],

            // 关系表类型
            times: [],
            // 查询参数
            queryParams: {
                pageIndex: 1,
                pageSize: 10,
                startTime: undefined,
                endTime: undefined,
                machineId: undefined,
                biosId: undefined,
                idOrder: 'desc',
            },
            // 表单参数
            form: {
            },
            // 表单校验
            rules: {
                machineId: [{ required: true, message: '设备id不能为空', trigger: 'blur' }],
                biosId: [{ required: true, message: '设备码不能为空', trigger: 'blur' }],
            },
            pickerOptions: {
                shortcuts: [{
                    text: '最近一周',
                    onClick(picker) {
                        const end = new Date();
                        const start = new Date();
                        start.setTime(start.getTime() - 3600 * 1000 * 24 * 7);
                        picker.$emit('pick', [start, end]);
                    }
                }, {
                    text: '最近一个月',
                    onClick(picker) {
                        const end = new Date();
                        const start = new Date();
                        start.setTime(start.getTime() - 3600 * 1000 * 24 * 30);
                        picker.$emit('pick', [start, end]);
                    }
                }, {
                    text: '最近三个月',
                    onClick(picker) {
                        const end = new Date();
                        const start = new Date();
                        start.setTime(start.getTime() - 3600 * 1000 * 24 * 90);
                        picker.$emit('pick', [start, end]);
                    }
                }]
            },
        }
    },
    created() {
        this.getList()
        this.getMachineList()
    },
    methods: {
        /** 查询参数列表 */
        getList() {
            this.loading = true
            this.queryParams.startTime = undefined
            this.queryParams.endTime = undefined

            if (this.times) {
                console.log(this.times.length)
                if (this.times.length >= 0) {
                    this.queryParams.startTime = this.times[0]
                }

                if (this.times.length >= 1) {
                    this.queryParams.endTime = this.times[1]
                }
            }
            listMmAlarmLog(this.queryParams).then(response => {
                this.mmAlarmLogList = response.data.list
                this.total = response.data.count
                this.loading = false
            }
            )
        },
        getMachineList() {
            getMmMachineList().then(response => {
                this.machineIdOptions = response.data
            })
        },
        // 取消按钮
        cancel() {
            this.open = false
            this.reset()
        },
        // 表单重置
        reset() {
            this.form = {

                id: undefined,
                machineId: undefined,
                biosId: undefined,
                content: undefined,
            }
            this.resetForm('form')
        },
        getImgList: function () {
            this.form[this.fileIndex] = this.$refs['fileChoose'].resultList[0].fullUrl
        },
        fileClose: function () {
            this.fileOpen = false
        },
        // 关系
        // 文件
        /** 搜索按钮操作 */
        handleQuery() {
            this.queryParams.pageIndex = 1
            this.getList()
        },
        /** 重置按钮操作 */
        resetQuery() {
            this.dateRange = []
            this.resetForm('queryForm')
            this.handleQuery()
        },
        /** 新增按钮操作 */
        handleAdd() {
            this.reset()
            this.open = true
            this.title = '添加钱包告警记录'
            this.isEdit = false
        },
        // 多选框选中数据
        handleSelectionChange(selection) {
            this.ids = selection.map(item => item.id)
            this.single = selection.length !== 1
            this.multiple = !selection.length
        },
        /** 修改按钮操作 */
        handleUpdate(row) {
            this.reset()
            const id =
                row.id || this.ids
            getMmAlarmLog(id).then(response => {
                this.form = response.data
                this.open = true
                this.title = '修改钱包告警记录'
                this.isEdit = true
            })
        },
        /** 提交按钮 */
        submitForm: function () {
            this.$refs['form'].validate(valid => {
                if (valid) {
                    if (this.form.id !== undefined) {
                        updateMmAlarmLog(this.form).then(response => {
                            if (response.code === 200) {
                                this.msgSuccess(response.msg)
                                this.open = false
                                this.getList()
                            } else {
                                this.msgError(response.msg)
                            }
                        })
                    } else {
                        addMmAlarmLog(this.form).then(response => {
                            if (response.code === 200) {
                                this.msgSuccess(response.msg)
                                this.open = false
                                this.getList()
                            } else {
                                this.msgError(response.msg)
                            }
                        })
                    }
                }
            })
        },
        /** 删除按钮操作 */
        handleDelete(row) {
            var Ids = (row.id && [row.id]) || this.ids

            this.$confirm('是否确认删除编号为"' + Ids + '"的数据项?', '警告', {
                confirmButtonText: '确定',
                cancelButtonText: '取消',
                type: 'warning'
            }).then(function () {
                return delMmAlarmLog({ 'ids': Ids })
            }).then((response) => {
                if (response.code === 200) {
                    this.msgSuccess(response.msg)
                    this.open = false
                    this.getList()
                } else {
                    this.msgError(response.msg)
                }
            }).catch(function () {
            })
        },
        handleClearAll() {
            this.loading = true

            clearAllAlarmLog().then(response => {
                if (response.code === 200) {
                    this.msgSuccess(response.msg)
                    this.getList()
                } else {
                    this.msgError(response.msg)
                }
            }).catch(error => {
                console.log(error)
            }).finally(() => {
                this.loading = false
            })
        },
        // 导出按钮
        handleExport() {
            this.loading = true
            this.queryParams.startTime = undefined
            this.queryParams.endTime = undefined

            if (this.times) {
                console.log(this.times.length)
                if (this.times.length >= 0) {
                    this.queryParams.startTime = this.times[0]
                }

                if (this.times.length >= 1) {
                    this.queryParams.endTime = this.times[1]
                }
            }

            exportMmAlarmLog(this.queryParams)
                .then(response => {
                    console.log(response)
                    resolveBlob(response, '钱包告警记录.xlsx')
                    this.msgSuccess('导出成功')
                })
                .catch(err => {
                    console.log(err)
                })
                .finally(() => {
                    this.loading = false
                })
        }
    }
}
</script>
